/* TAGS: ext c++ todo */
/* VERIFY_OPTS: -o nofail:malloc */
/* CC_OPTS: -std=c++17 -I$SRC_ROOT/bricks */

#include <pthread.h>
#include <thread>
#include <cassert>
#include <brick-hashset>

brq::concurrent_hash_set< int, brq::impl::grow< 1, 2, 4 >, 4 > set1, set2( set1 );

void *thread( void * )
{
    set2.insert( 1 );
    return nullptr;
}

int main()
{
    pthread_t tid;
    pthread_create( &tid, nullptr, thread, nullptr );

    bool erased = set1.erase( 1 );
    pthread_join( tid, nullptr );

    if ( erased )
        ASSERT( !set1.count( 1 ) );
    else
        ASSERT( set1.count( 1 ) );
}
