/* TAGS: min c */
#include <sys/divm.h>
#include <assert.h>

int calls = 0;
int expect_taint = 0;

void is_tainted( int v, int t ) { assert( expect_taint ); ++ calls; }
void not_tainted( int v ) { assert( !expect_taint ); ++ calls; }

void __vm_test_taint( void (*)( int, int ), void (*)( int ), int );

void check_taint( int v, int expect )
{
    expect_taint = expect;
    __vm_test_taint( is_tainted, not_tainted, v );
}

int main()
{
    int a = 13;
    check_taint( a, 0 );
    __vm_pointer_t ptr = __vm_pointer_split( &a );
    __vm_poke( _VM_ML_Taints, ptr.obj, ptr.off, sizeof( a ), 0xf );
    check_taint( a, 1 );
    assert( calls == 2 );
    return 0;
}

